<script setup lang="ts">
import { computed, onMounted, ref } from "vue";
import { useDeliverymethodStore } from "@/stores/deliverymethod";
import { usePaymentmethodStore } from "@/stores/paymentmethod";
import { useCartStore } from "@/stores/cart";
import { useOrderStore } from "@/stores/order";
import AddressDialog from "./AddressDialog.vue";
import UseProDialog from "../promotion/UseProDialog.vue";
import type promotion from "@/services/promotion";
import { usePromotionStore } from "@/stores/promotion";
const deliveryStore = useDeliverymethodStore();
const paymentStore = usePaymentmethodStore();
const cartStore = useCartStore();
const orderStore = useOrderStore();
const promotionStore = usePromotionStore();
// const selectedDeliveryId = ref(null);
// const selectedPaymentId = ref(null);
import { useRouter } from 'vue-router';
import { watch } from 'vue';
const router = useRouter();
onMounted(() => {
    deliveryStore.getDeliverymethod();
    paymentStore.getPaymentmethod();
    cartStore.getCartItem();
});
const isPaymentEnabled = computed(() => {
    return !!deliveryStore.selectedDeliveryId && !!paymentStore.selectedPaymentId;
});
const isAddressAdded = computed(() => {
    return !!orderStore.editedOrder.address;
});
const proceedToPayment = () => {
    if (paymentStore.selectedPaymentId === 1 && isAddressAdded.value) {
        router.push("/creditpayment");
    } else if (paymentStore.selectedPaymentId === 2 && isAddressAdded.value) {
        router.push("/qrpayment");
    }
};
watch(() => orderStore.editedOrder.address, (newAddress) => {
    const addButton = document.querySelector('.add-address-btn');
    if (newAddress !== null && newAddress !== undefined && addButton instanceof HTMLElement) {
        addButton.innerText = newAddress;
    }
});

</script>

<template>
    <UseProDialog></UseProDialog>
    <AddressDialog></AddressDialog>
    <v-card theme="light" height="919" outlined="false">
        <v-row class="mt-5">
            <v-col cols="4"></v-col>
            <v-col cols="6"><span class="fontTitle ml-14">สรุปรายการสั่งซื้อสินค้า</span></v-col>
            <v-col cols="2">

            </v-col>
        </v-row>
        <v-row>
            <v-col cols="1"></v-col>
            <v-col cols="8">
                <v-card theme="light" height="640px" width="1200px" class="ma-5 " outlined="false"
                    style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1); ">
                    <v-row class="mt-8">
                        <v-col cols="4"><span class="fontTitle ml-14">รูปแบบการจัดส่ง :</span></v-col>
                        <v-col>
                            <v-row v-for="item of deliveryStore.deliverymethods" :key="item.id">
                                <v-checkbox :label="`${item.name}  ${item.description} ฿ ${item.price}`"
                                    :value="item.id" v-model="deliveryStore.selectedDeliveryId"
                                    @change="item.id !== undefined && orderStore.setDeliveryMethod(item)">

                                </v-checkbox>
                            </v-row>
                            <!-- <v-row v-for="item of deliveryStore.deliverymethods" :key="item.id">
                                <v-checkbox :label="`${item.name}  ${item.description} ฿ ${item.price}`"
                                    :value="item.id" v-model="deliveryStore.selectedDeliveryId">
                                </v-checkbox>
                            </v-row> -->
                        </v-col>
                    </v-row>

                    <v-row>
                        <v-col cols="4"><span class="fontTitle ml-14">ที่อยู่การจัดส่ง :</span></v-col>
                        <v-col cols="6">
                            <!-- <v-btn @click="orderStore.dialog = true"> + เพิ่มที่อยู่การจัดส่ง</v-btn> -->
                            <!-- <v-btn width="auto" class="font add-address-btn" @click="orderStore.dialog = true">
                                + {{ orderStore.editedOrder.address ? orderStore.editedOrder.address : 'เพิ่มที่อยู่การจัดส่ง' }}</v-btn> -->
                            <v-btn width="auto" class="font add-address-btn" @click="orderStore.dialog = true">
                                + <span class="add-address-text">{{ orderStore.editedOrder.address ?
                                orderStore.editedOrder.address : 'เพิ่มที่อยู่การจัดส่ง' }}</span>
                            </v-btn>

                        </v-col>
                        <v-col cols="2"></v-col>
                    </v-row>
                    <v-row>
                        <v-col cols="4"><span class="fontTitle ml-14">วิธีการชำระเงิน :</span></v-col>
                        <v-col>
                            <v-row v-for="item of paymentStore.Paymentmethods" :key="item.id">
                                <v-checkbox :label="item.name" v-model="paymentStore.selectedPaymentId"
                                    :value="item.id"></v-checkbox>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-card>
            </v-col>
            <v-col cols="3">
                <v-card theme="light" height="640px" width="400px" class="ma-5" outlined="false"
                    style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1);">
                    <v-row class="ma-8">
                        <v-col></v-col>
                        <v-col><v-btn class="font" @click="promotionStore.usePro = true">โปรโมชัน</v-btn></v-col>
                        <v-col></v-col>
                    </v-row>

                    <v-row class="ma-8 ">
                        <v-col cols="8"><span class="font">ค่าจัดส่ง</span></v-col>
                        <v-col cols="4">฿{{ deliveryStore.deliveryPrice }}</v-col>

                    </v-row>
                    <v-row class="ma-8">
                        <v-col cols="8"><span class="font">ยอดรวม</span></v-col>
                        <v-col cols="4">฿{{ cartStore.sumPrice.toLocaleString() }}</v-col>
                    </v-row>
                    <v-row class="ma-8">
                        <v-col cols="8"><span class="font">ส่วนลด</span></v-col>
                        <v-col cols="4">฿{{ orderStore.editedOrder.discount }}</v-col>
                    </v-row>
                    <v-row class="ma-8">
                        <v-col cols="8"><span class="font">ยอดรวมสุทธิ</span></v-col>
                        <v-col cols="4">฿{{ orderStore.editedOrder.totalPrice.toLocaleString() }}</v-col>
                    </v-row>
                    <v-row class="ma-8">
                        <v-col></v-col>
                        <v-col>
                            <!-- <v-btn class="font" to="qrpayment" :disabled="!isPaymentEnabled || !isAddressAdded">ดําเนินการชําระเงิน</v-btn> -->
                            <v-btn class="font" :disabled="!isPaymentEnabled || !isAddressAdded"
                                @click="proceedToPayment">ดำเนินการชำระเงิน</v-btn>
                        </v-col>
                        <v-col></v-col>
                    </v-row>
                    <v-row class="ma-8">
                        <v-col></v-col>
                        <v-col><v-btn class="font" to="/cartview">ยกเลิก</v-btn></v-col>
                        <v-col></v-col>
                    </v-row>

                </v-card>
            </v-col>
        </v-row>
    </v-card>
</template>

<style scoped>
.add-address-text {
    white-space: pre-line;
    word-wrap: break-word;
}

.fontTitle {
    text-align-last: center;
    font-family: fantasy;
    font-size: 20px;
    color: black;
}

.font {
    text-align-last: center;
    font-family: fantasy;
    font-size: 18px;
    color: black;
}

.fontcardtitle {
    text-align-last: center;
    font-family: fantasy;
    font-size: 25px;
    color: black;
}

.fontcard {
    text-align-last: center;
    font-family: fantasy;
    font-size: 18px;
    color: black;
}

.fontdate {
    text-align-last: center;
    font-family: fantasy;
    font-size: 14px;
    color: black;
}
</style>